/*
    Copyright 2005-2008 EPOS-Project
                        (FZ Dresden-Rossendorf & MLU Halle-Wittenberg)
                        Arnold Krille <arnold@arnoldarts.de>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; version 3 of the License.

    This program is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; see the file gpl-3.0.txt. If not, see
    <http://www.gnu.org/licenses/>.

*/

#include <QtCore/QCoreApplication>
#include <QtCore/QTimer>
#include <QtCore/QDebug>
#include <cstdlib>

#include "datasetchain.h"
#include "datasetchain_test.h"
#include "datasetchain_test.moc"

using namespace Test;

int main( int argc, char** argv )
{
	qDebug() << "DataSetChain_Test starting";
	srand( time( 0 ) );

	QCoreApplication qapp( argc, argv );

	Producer* producer = new Producer();
	producer->toProduce = 100;

	ChainMember* chainmember = new ChainMember();
	Consumer* consumer = new Consumer();
	Consumer* consumer2 = new Consumer();

	qDebug() << "producer    =" << producer << endl
	         << "chainmember =" << chainmember << endl
	         << "consumer    =" << consumer << endl
	         << "consumer2   =" << consumer2 << endl
	         ;

	producer->registerConsumer( consumer2 );
	consumer2->registerConsumer( chainmember );
	chainmember->registerConsumer( consumer );

	qDebug() << endl << "Doing runtime-tests...";

	QTimer::singleShot( 0, producer, SLOT( produceData() ) );
	int ret = qapp.exec();

	qDebug() << endl << "Ending DataSetChain_Test...";

	delete producer;
	delete consumer;
	delete chainmember;

	return ret;
}

