/*
    Copyright 2005-2008 EPOS-Project
                        (FZ Dresden-Rossendorf & MLU Halle-Wittenberg)
                        Arnold Krille <arnold@arnoldarts.de>

    This library is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as
    published by the Free Software Foundation; version 3 of the License.

    This library is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; see the files lgpl-3.0.txt and
    gpl-3.0.txt. If not, see <http://www.gnu.org/licenses/>.

*/

#include "led.h"
#include "led.moc"

#include <QtGui/QPainter>

LED::LED( QWidget* p ) : QLabel( p ), _state( Off ) {
	setAlignment( Qt::AlignCenter );
	setColor();
}
LED::~LED() {
}

void LED::setOn() { _state = On; setColor(); }
void LED::setOff() { _state = Off; setColor(); }
void LED::setError() { _state = Error; setColor(); }

void LED::setColor() {
	QColor tmp;
	tmp.setNamedColor( "Green" );
	setText( "Running..." );
	if ( _state == Error ) {
		tmp.setNamedColor( "Red" );
		setText( "ERROR!" );
	}
	if ( _state == Off ) {
		tmp.setNamedColor( "Yellow" );
		setText( "Ready to roll" );
	}
	_color = tmp;
//	setBackgroundColor( tmp );
}

void LED::paintEvent( QPaintEvent* e ) {
	QPainter p( this );
	p.setBrush( _color );
	p.drawRect( rect() );
	QLabel::paintEvent( e );
}

